"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const rpscript_interface_1 = require("rpscript-interface");
const lodash_1 = __importDefault(require("lodash"));
const async_1 = __importDefault(require("async"));
/** Module for Lodash
 * @namespace Lodash
 *
 * @see {@link https://lodash.com/docs}
*/
let RpsLodash = class RpsLodash {
    //Array
    /**
   * @function chunk
   * @memberof Lodash
   *
   * @param {Array} array
   * @param {number} size
   * @returns {Array}
   *
   * @see {@link https://lodash.com/docs#chunk}
  */
    chunk(ctx, opts, array, size = 1) {
        return Promise.resolve(lodash_1.default.chunk(array, size));
    }
    /**
   * @function compact
   * @memberof Lodash
   *
   * @param {Array} array
   * @returns {Array}
   *
   * @see {@link https://lodash.com/docs#compact}
  */
    compact(ctx, opts, array) {
        return Promise.resolve(lodash_1.default.compact(array));
    }
    /**
     * @function concat
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {List} values
     *
     * @see {@link https://lodash.com/docs#concat}
    */
    concat(ctx, opts, array, ...values) {
        let val = [array].concat(values);
        return Promise.resolve(lodash_1.default.concat.apply(this, val));
    }
    /**
     * @function difference
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array} values
     *
     * @see {@link https://lodash.com/docs#difference}
    */
    difference(ctx, opts, array, values) {
        return Promise.resolve(lodash_1.default.difference(array, values));
    }
    /**
   * @function drop
   * @memberof Lodash
   *
   * @param {Array} array
   * @returns {number} size
   *
   * @see {@link https://lodash.com/docs#drop}
  */
    drop(ctx, opts, array, size = 1) {
        return Promise.resolve(lodash_1.default.drop(array, size));
    }
    /**
   * @function drop-right
   * @memberof Lodash
   *
   * @param {Array} array
   * @returns {number} size
   *
   * @see {@link https://lodash.com/docs#dropRight}
  */
    dropRight(ctx, opts, array, size = 1) {
        return Promise.resolve(lodash_1.default.dropRight(array, size));
    }
    /**
   * @function fill
   * @memberof Lodash
   *
   * @param {Array} array
   * @returns {Array} values
   *
   * @see {@link https://lodash.com/docs#fill}
  */
    fill(ctx, opts, array, value) {
        return Promise.resolve(lodash_1.default.fill(array, value));
    }
    /**
     * @function find-index
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array} values
     *
     * @see {@link https://lodash.com/docs#findIndex}
    */
    findIndex(ctx, opts, array, predicate, fromIndex = 0) {
        return Promise.resolve(lodash_1.default.findIndex(array, predicate, fromIndex));
    }
    /**
     * @function find-last-index
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array} values
     *
     * @see {@link https://lodash.com/docs#findLastIndex}
    */
    findLastIndex(ctx, opts, array, predicate, fromIndex = 0) {
        return Promise.resolve(lodash_1.default.findLastIndex(array, predicate, fromIndex));
    }
    /**
     * @function flatten
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#flatten}
    */
    flatten(ctx, opts, array) {
        return Promise.resolve(lodash_1.default.flatten(array));
    }
    /**
     * @function flatten-deep
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#flattenDeep}
    */
    flattenDeep(ctx, opts, array) {
        return Promise.resolve(lodash_1.default.flattenDeep(array));
    }
    /**
     * @function from-pairs
     * @memberof Lodash
     *
     * @param {Array} pairs
     * @returns {Object}
     *
     * @see {@link https://lodash.com/docs#fromPairs}
    */
    fromPairs(ctx, opts, pairs) {
        return Promise.resolve(lodash_1.default.fromPairs(pairs));
    }
    /**
     * @function head
     * @memberof Lodash
     *
     * @param {Array}
     * @returns {Object}
     *
     * @see {@link https://lodash.com/docs#head}
    */
    head(ctx, opts, array) {
        return Promise.resolve(lodash_1.default.head(array));
    }
    /**
     * @function index-of
     * @memberof Lodash
     *
     * @param {Array} array
     * @param {*} value
     * @param {number} fromIndex optional.
     * @returns {number}
     *
     * @see {@link https://lodash.com/docs#indexOf}
    */
    indexOf(ctx, opts, array, value, fromIndex = 1) {
        return Promise.resolve(lodash_1.default.indexOf(array, value, fromIndex));
    }
    /**
   * @function initial
   * @memberof Lodash
   *
   * @param {Array} array
   * @returns {Array}
   *
   * @see {@link https://lodash.com/docs#initial}
  */
    initial(ctx, opts, array) {
        return Promise.resolve(lodash_1.default.initial(array));
    }
    /**
     * @function intersection
     * @memberof Lodash
     *
     * @param {Array} arrays
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#intersection}
    */
    intersection(ctx, opts, arrays) {
        return Promise.resolve(lodash_1.default.intersection(arrays));
    }
    /**
     * @function join
     * @memberof Lodash
     *
     * @param {Array} array
     * @param {Array} separator
     * @returns {string}
     *
     * @see {@link https://lodash.com/docs#intersection}
    */
    join(ctx, opts, array, separator = ',') {
        return Promise.resolve(lodash_1.default.join(array, separator));
    }
    /**
     * @function last
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#last}
    */
    last(ctx, opts, array) {
        return Promise.resolve(lodash_1.default.last(array));
    }
    /**
     * @function last-index-of
     * @memberof Lodash
     *
     * @param {Array} array
     * @param {*} value
     * @param {number} fromIndex
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#lastIndexOf}
    */
    lastIndexOf(ctx, opts, array, value, fromIndex) {
        return Promise.resolve(lodash_1.default.lastIndexOf(array, value, fromIndex));
    }
    /**
     * @function nth
     * @memberof Lodash
     *
     * @param {Array} array
     * @param {*} n
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#nth}
    */
    nth(ctx, opts, array, n = 0) {
        return Promise.resolve(lodash_1.default.nth(array, n));
    }
    /**
     * @function pull
     * @memberof Lodash
     *
     * @param {Array} array
     * @param {*} values
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#pull}
    */
    pull(ctx, opts, array, ...values) {
        let v = [array].concat(values);
        return Promise.resolve(lodash_1.default.pull.apply(this, v));
    }
    /**
     * @function pull-all
     * @memberof Lodash
     *
     * @param {Array} array
     * @param {*} values
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#pullAll}
    */
    pullAll(ctx, opts, array, values) {
        return Promise.resolve(lodash_1.default.pullAll(array, values));
    }
    /**
     * @function pull-all-by
     * @memberof Lodash
     *
     * @param {Array} array
     * @param {*} values
     * @param {*} function
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#pullAllBy}
    */
    pullAllBy(ctx, opts, array, values, fn) {
        return Promise.resolve(lodash_1.default.pullAllBy(array, values, fn));
    }
    /**
     * @function remove
     * @memberof Lodash
     *
     * @param {Array} array
     * @param {*} predicate
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#remove}
    */
    remove(ctx, opts, array, predicate) {
        return Promise.resolve(lodash_1.default.remove(array, predicate));
    }
    /**
     * @function reverse
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#reverse}
    */
    reverse(ctx, opts, array) {
        return Promise.resolve(lodash_1.default.reverse(array));
    }
    /**
     * @function slice
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#slice}
    */
    slice(ctx, opts, array, start = 0, end) {
        return Promise.resolve(lodash_1.default.slice(array, start, end));
    }
    /**
     * @function sorted-index
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#sortedIndex}
    */
    sortedIndex(ctx, opts, array, value) {
        return Promise.resolve(lodash_1.default.sortedIndex(array, value));
    }
    /**
     * @function sorted-uniq
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#sortedUniq}
    */
    sortedUniq(ctx, opts, array) {
        return Promise.resolve(lodash_1.default.sortedUniq(array));
    }
    /**
     * @function tail
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#tail}
    */
    tail(ctx, opts, array) {
        return Promise.resolve(lodash_1.default.tail(array));
    }
    /**
     * @function take
     * @memberof Lodash
     *
     * @param {Array} array
     * @param {number} n
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#take}
    */
    take(ctx, opts, array, n = 1) {
        return Promise.resolve(lodash_1.default.take(array, n));
    }
    /**
     * @function take-right
     * @memberof Lodash
     *
     * @param {Array} array
     * @param {number} n
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#takeRight}
    */
    takeRight(ctx, opts, array, n = 1) {
        return Promise.resolve(lodash_1.default.takeRight(array, n));
    }
    /**
     * @function union
     * @memberof Lodash
     *
     * @param {Array} arrays
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#union}
    */
    union(ctx, opts, ...arrays) {
        return Promise.resolve(lodash_1.default.union.apply(this, arrays));
    }
    /**
     * @function uniq
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#uniq}
    */
    uniq(ctx, opts, array) {
        return Promise.resolve(lodash_1.default.uniq(array));
    }
    /**
     * @function unzip
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#unzip}
    */
    unzip(ctx, opts, ...array) {
        return Promise.resolve(lodash_1.default.unzip.apply(this, array));
    }
    /**
     * @function without
     * @memberof Lodash
     *
     * @param {Array} array
     * @param {List} values
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#without}
    */
    without(ctx, opts, array, ...values) {
        let v = [array].concat(values);
        return Promise.resolve(lodash_1.default.without.apply(this, v));
    }
    /**
     * @function xor
     * @memberof Lodash
     *
     * @param {Array} arrays
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#xor}
    */
    xor(ctx, opts, ...array) {
        return Promise.resolve(lodash_1.default.xor.apply(this, array));
    }
    /**
     * @function zip
     * @memberof Lodash
     *
     * @param {Array} array
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#zip}
    */
    zip(ctx, opts, ...array) {
        return Promise.resolve(lodash_1.default.zip.apply(this, array));
    }
    /**
     * @function zip-object
     * @memberof Lodash
     *
     * @param {Array} properties
     * @param {Array} values
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#zipObject}
    */
    zipObject(ctx, opts, properties, values) {
        return Promise.resolve(lodash_1.default.zipObject(properties, values));
    }
    /**
     * @function zip-object-deep
     * @memberof Lodash
     *
     * @param {Array} properties
     * @param {Array} values
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#zipObjectDeep}
    */
    zipObjectDeep(ctx, opts, properties, values) {
        return Promise.resolve(lodash_1.default.zipObject(properties, values));
    }
    /**
     * @function zip-with
     * @memberof Lodash
     *
     * @param {Array} properties
     * @param {Array} values
     * @returns {Array}
     *
     * @see {@link https://lodash.com/docs#zipWith}
    */
    zipWith(ctx, opts, identity, ...arrays) {
        let v = arrays.concat(identity);
        return Promise.resolve(lodash_1.default.zipWith.apply(this, v));
    }
    // ******** COLLECTION *******
    map(ctx, opts, functor, fn) {
        var func = (val, cb) => __awaiter(this, void 0, void 0, function* () { return cb(null, yield fn(val)); });
        return new Promise((resolve, reject) => {
            async_1.default.mapSeries(functor, func, (err, results) => {
                if (err)
                    reject(err);
                else
                    resolve(results);
            });
        });
    }
    filter(ctx, opts, functor, fn) {
        var func = (val, cb) => __awaiter(this, void 0, void 0, function* () { return cb(null, yield fn(val)); });
        return new Promise((resolve, reject) => {
            async_1.default.filterSeries(functor, func, (err, results) => {
                if (err)
                    reject(err);
                else
                    resolve(results);
            });
        });
    }
    find(ctx, opts, functor, fn) {
        return Promise.resolve(lodash_1.default.find(functor, fn));
    }
    keys(ctx, opts, functor, fn) {
        return Promise.resolve(lodash_1.default.keys(functor));
    }
    values(ctx, opts, functor, fn) {
        return Promise.resolve(lodash_1.default.values(functor));
    }
    pick(ctx, opts, functor, fn) {
        return Promise.resolve(lodash_1.default.pick(functor, fn));
    }
    forEach(ctx, opts, functor, fn) {
        return __awaiter(this, void 0, void 0, function* () {
            for (var i = 0; i < functor.length; i++) {
                let item = functor[i];
                yield fn(item);
            }
        });
    }
    now(ctx, opts) {
        return Promise.resolve(new Date(lodash_1.default.now()));
    }
    // ******** STRING *******
    camelCase(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.camelCase(text));
    }
    capitalize(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.capitalize(text));
    }
    deburr(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.deburr(text));
    }
    endsWith(ctx, opts, target, text) {
        let position = opts['position'];
        return Promise.resolve(lodash_1.default.endsWith(text, target, position));
    }
    escape(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.escape(text));
    }
    escapeRegExp(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.escapeRegExp(text));
    }
    kebabCase(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.kebabCase(text));
    }
    lowerCase(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.lowerCase(text));
    }
    lowerFirst(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.lowerFirst(text));
    }
    pad(ctx, opts, length, text) {
        let chars = opts['chars'];
        return Promise.resolve(lodash_1.default.pad(text, length, chars));
    }
    padEnd(ctx, opts, length, text) {
        let chars = opts['chars'];
        return Promise.resolve(lodash_1.default.padEnd(text, length, chars));
    }
    padStart(ctx, opts, length, text) {
        let chars = opts['chars'];
        return Promise.resolve(lodash_1.default.padStart(text, length, chars));
    }
    parseInt(ctx, opts, text) {
        let radix = opts['radix'];
        return Promise.resolve(lodash_1.default.parseInt(text, radix));
    }
    repeat(ctx, opts, n, text) {
        return Promise.resolve(lodash_1.default.repeat(text, n));
    }
    replace(ctx, opts, pattern, replacement, text) {
        return Promise.resolve(lodash_1.default.replace(text, pattern, replacement));
    }
    snakeCase(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.snakeCase(text));
    }
    split(ctx, opts, separator, text) {
        return Promise.resolve(lodash_1.default.split(text, separator));
    }
    startCase(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.startCase(text));
    }
    startsWith(ctx, opts, target, text) {
        let position = opts['position'];
        return Promise.resolve(lodash_1.default.startsWith(text, target, position));
    }
    template(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.template(text, opts));
    }
    toLower(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.toLower(text));
    }
    toUpper(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.toUpper(text));
    }
    trim(ctx, opts, text) {
        let chars = opts['chars'];
        return Promise.resolve(lodash_1.default.trim(text, chars));
    }
    trimEnd(ctx, opts, text) {
        let chars = opts['chars'];
        return Promise.resolve(lodash_1.default.trimEnd(text, chars));
    }
    trimStart(ctx, opts, text) {
        let chars = opts['chars'];
        return Promise.resolve(lodash_1.default.trimStart(text, chars));
    }
    truncate(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.truncate(text, opts));
    }
    unescape(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.unescape(text));
    }
    upperCase(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.upperCase(text));
    }
    upperFirst(ctx, opts, text) {
        return Promise.resolve(lodash_1.default.upperFirst(text));
    }
    words(ctx, opts, pattern, text) {
        return Promise.resolve(lodash_1.default.words(text, pattern));
    }
    // ******** CUSTOMIZE *******
    regex(ctx, opts, pattern, flags) {
        return Promise.resolve(new RegExp(pattern, flags));
    }
    getLodashFunction(ctx, opts, fnName, ...params) {
        if (params.length == 0)
            return Promise.resolve(lodash_1.default[fnName]);
        else
            return lodash_1.default[fnName].apply(this, params);
    }
};
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'chunk' })
], RpsLodash.prototype, "chunk", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'compact' })
], RpsLodash.prototype, "compact", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'concat' })
], RpsLodash.prototype, "concat", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'difference' })
], RpsLodash.prototype, "difference", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'drop' })
], RpsLodash.prototype, "drop", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'drop-right' })
], RpsLodash.prototype, "dropRight", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'fill' })
], RpsLodash.prototype, "fill", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'find-index' })
], RpsLodash.prototype, "findIndex", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'find-last-index' })
], RpsLodash.prototype, "findLastIndex", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'flatten' })
], RpsLodash.prototype, "flatten", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'flatten-deep' })
], RpsLodash.prototype, "flattenDeep", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'from-pairs' })
], RpsLodash.prototype, "fromPairs", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'head' })
], RpsLodash.prototype, "head", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'index-of' })
], RpsLodash.prototype, "indexOf", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'initial' })
], RpsLodash.prototype, "initial", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'intersection' })
], RpsLodash.prototype, "intersection", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'join' })
], RpsLodash.prototype, "join", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'last' })
], RpsLodash.prototype, "last", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'last-index-of' })
], RpsLodash.prototype, "lastIndexOf", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'nth' })
], RpsLodash.prototype, "nth", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'pull' })
], RpsLodash.prototype, "pull", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'pull-all' })
], RpsLodash.prototype, "pullAll", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'pull-all-by' })
], RpsLodash.prototype, "pullAllBy", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'remove' })
], RpsLodash.prototype, "remove", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'reverse' })
], RpsLodash.prototype, "reverse", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'slice' })
], RpsLodash.prototype, "slice", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'sorted-index' })
], RpsLodash.prototype, "sortedIndex", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'sorted-uniq' })
], RpsLodash.prototype, "sortedUniq", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'tail' })
], RpsLodash.prototype, "tail", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'take' })
], RpsLodash.prototype, "take", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'take-right' })
], RpsLodash.prototype, "takeRight", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'union' })
], RpsLodash.prototype, "union", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'uniq' })
], RpsLodash.prototype, "uniq", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'unzip' })
], RpsLodash.prototype, "unzip", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'without' })
], RpsLodash.prototype, "without", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'xor' })
], RpsLodash.prototype, "xor", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'zip' })
], RpsLodash.prototype, "zip", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'zip-object' })
], RpsLodash.prototype, "zipObject", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'zip-object-deep' })
], RpsLodash.prototype, "zipObjectDeep", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'zip-with' })
], RpsLodash.prototype, "zipWith", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'map' })
], RpsLodash.prototype, "map", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'filter' })
], RpsLodash.prototype, "filter", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'find' })
], RpsLodash.prototype, "find", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'keys' })
], RpsLodash.prototype, "keys", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'values' })
], RpsLodash.prototype, "values", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'pick' })
], RpsLodash.prototype, "pick", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'for-each' })
], RpsLodash.prototype, "forEach", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'date-now' })
], RpsLodash.prototype, "now", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'camel-case' })
], RpsLodash.prototype, "camelCase", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'capitalize' })
], RpsLodash.prototype, "capitalize", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'deburr' })
], RpsLodash.prototype, "deburr", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'ends-with' })
], RpsLodash.prototype, "endsWith", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'escape' })
], RpsLodash.prototype, "escape", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'escape-regexp' })
], RpsLodash.prototype, "escapeRegExp", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'kebab-case' })
], RpsLodash.prototype, "kebabCase", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'lower-case' })
], RpsLodash.prototype, "lowerCase", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'lower-first' })
], RpsLodash.prototype, "lowerFirst", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'pad' })
], RpsLodash.prototype, "pad", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'pad-end' })
], RpsLodash.prototype, "padEnd", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'pad-start' })
], RpsLodash.prototype, "padStart", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'parse-int' })
], RpsLodash.prototype, "parseInt", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'repeat' })
], RpsLodash.prototype, "repeat", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'replace' })
], RpsLodash.prototype, "replace", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'snake-case' })
], RpsLodash.prototype, "snakeCase", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'split' })
], RpsLodash.prototype, "split", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'start-case' })
], RpsLodash.prototype, "startCase", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'starts-with' })
], RpsLodash.prototype, "startsWith", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'template' })
], RpsLodash.prototype, "template", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'to-lower' })
], RpsLodash.prototype, "toLower", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'to-upper' })
], RpsLodash.prototype, "toUpper", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'trim' })
], RpsLodash.prototype, "trim", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'trim-end' })
], RpsLodash.prototype, "trimEnd", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'trim-start' })
], RpsLodash.prototype, "trimStart", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'truncate' })
], RpsLodash.prototype, "truncate", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'unescape' })
], RpsLodash.prototype, "unescape", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'upper-case' })
], RpsLodash.prototype, "upperCase", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'upper-first' })
], RpsLodash.prototype, "upperFirst", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'words' })
], RpsLodash.prototype, "words", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'regex' })
], RpsLodash.prototype, "regex", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'lodash' })
], RpsLodash.prototype, "getLodashFunction", null);
RpsLodash = __decorate([
    rpscript_interface_1.RpsModule("lodash")
], RpsLodash);
exports.default = RpsLodash;
